# CfnCluster

The `AWS::EMR::Cluster` resource specifies an Amazon EMR cluster.

This cluster is a collection of Amazon EC2 instances that run open source big data frameworks and applications to process and analyze vast amounts of data. For more information, see the [Amazon EMR Management Guide](https://docs.aws.amazon.com//emr/latest/ManagementGuide/) .

Amazon EMR now supports launching task instance groups and task instance fleets as part of the `AWS::EMR::Cluster` resource. This can be done by using the `JobFlowInstancesConfig` property type's `TaskInstanceGroups` and `TaskInstanceFleets` subproperties. Using these subproperties reduces delays in provisioning task nodes compared to specifying task nodes with the `AWS::EMR::InstanceGroupConfig` and `AWS::EMR::InstanceFleetConfig` resources. Please refer to the examples at the bottom of this page to learn how to use these subproperties.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnCluster
Implements: IInspectable, ITaggable, IEnvironmentAware, IClusterRef, IConstruct, IDependable

- CloudFormation: [`AWS::EMR::Cluster`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-emr-cluster.html)
- Source: Generated code
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

```ts
// The generated example for this type would exceed 500 lines,
// and has been elided for readability.
```

## Initializer

```ts
new CfnCluster(scope: Construct, id: string, props: CfnClusterProps)
```

## Construct Props

- `additionalInfo`: any — A JSON string for selecting additional features.

- `applications`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.ApplicationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.ApplicationProperty.html)[] — The applications to install on this cluster, for example, Spark, Flink, Oozie, Zeppelin, and so on.

- `autoScalingRole`: string — An IAM role for automatic scaling policies.

  The default role is `EMR_AutoScaling_DefaultRole` . The IAM role provides permissions that the automatic scaling feature requires to launch and terminate Amazon EC2 instances in an instance group.

- `autoTerminationPolicy`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.AutoTerminationPolicyProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.AutoTerminationPolicyProperty.html) — An auto-termination policy for an Amazon EMR cluster.

  An auto-termination policy defines the amount of idle time in seconds after which a cluster automatically terminates. For alternative cluster termination options, see [Control cluster termination](https://docs.aws.amazon.com/emr/latest/ManagementGuide/emr-plan-termination.html) .

- `bootstrapActions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.BootstrapActionConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.BootstrapActionConfigProperty.html)[] — A list of bootstrap actions to run before Hadoop starts on the cluster nodes.

- `configurations`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.ConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.ConfigurationProperty.html)[] — Applies only to Amazon EMR releases 4.x and later. The list of configurations that are supplied to the Amazon EMR cluster.

- `customAmiId`: string — Available only in Amazon EMR releases 5.7.0 and later. The ID of a custom Amazon EBS-backed Linux AMI if the cluster uses a custom AMI.

- `ebsRootVolumeIops`: number — The IOPS, of the Amazon EBS root device volume of the Linux AMI that is used for each Amazon EC2 instance.

  Available in Amazon EMR releases 6.15.0 and later.

- `ebsRootVolumeSize`: number — The size, in GiB, of the Amazon EBS root device volume of the Linux AMI that is used for each Amazon EC2 instance.

  Available in Amazon EMR releases 4.x and later.

- `ebsRootVolumeThroughput`: number — The throughput, in MiB/s, of the Amazon EBS root device volume of the Linux AMI that is used for each Amazon EC2 instance.

  Available in Amazon EMR releases 6.15.0 and later.

- `instances`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.JobFlowInstancesConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.JobFlowInstancesConfigProperty.html) (required) — A specification of the number and type of Amazon EC2 instances.

- `jobFlowRole`: string (required) — Also called instance profile and Amazon EC2 role.

  An IAM role for an Amazon EMR cluster. The Amazon EC2 instances of the cluster assume this role. The default role is `EMR_EC2_DefaultRole` . In order to use the default role, you must have already created it using the AWS CLI or console.

- `kerberosAttributes`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.KerberosAttributesProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.KerberosAttributesProperty.html) — Attributes for Kerberos configuration when Kerberos authentication is enabled using a security configuration.

  For more information see [Use Kerberos Authentication](https://docs.aws.amazon.com/emr/latest/ManagementGuide/emr-kerberos.html) in the *Amazon EMR Management Guide* .

- `logEncryptionKmsKeyId`: string — The AWS KMS key used for encrypting log files.

  This attribute is only available with Amazon EMR 5.30.0 and later, excluding Amazon EMR 6.0.0.

- `logUri`: string — The path to the Amazon S3 location where logs for this cluster are stored.

- `managedScalingPolicy`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.ManagedScalingPolicyProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.ManagedScalingPolicyProperty.html) — Creates or updates a managed scaling policy for an Amazon EMR cluster.

  The managed scaling policy defines the limits for resources, such as Amazon EC2 instances that can be added or terminated from a cluster. The policy only applies to the core and task nodes. The master node cannot be scaled after initial configuration.

- `name`: string (required) — The name of the cluster.

  This parameter can't contain the characters <, >, $, |, or ` (backtick).

- `osReleaseLabel`: string — The Amazon Linux release specified in a cluster launch RunJobFlow request.

  If no Amazon Linux release was specified, the default Amazon Linux release is shown in the response.

- `placementGroupConfigs`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.PlacementGroupConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.PlacementGroupConfigProperty.html)[]

- `releaseLabel`: string — The Amazon EMR release label, which determines the version of open-source application packages installed on the cluster.

  Release labels are in the form `emr-x.x.x` , where x.x.x is an Amazon EMR release version such as `emr-5.14.0` . For more information about Amazon EMR release versions and included application versions and features, see [](https://docs.aws.amazon.com/emr/latest/ReleaseGuide/) . The release label applies only to Amazon EMR releases version 4.0 and later. Earlier versions use `AmiVersion` .

- `scaleDownBehavior`: string — The way that individual Amazon EC2 instances terminate when an automatic scale-in activity occurs or an instance group is resized.

  `TERMINATE_AT_INSTANCE_HOUR` indicates that Amazon EMR terminates nodes at the instance-hour boundary, regardless of when the request to terminate the instance was submitted. This option is only available with Amazon EMR 5.1.0 and later and is the default for clusters created using that version. `TERMINATE_AT_TASK_COMPLETION` indicates that Amazon EMR adds nodes to a deny list and drains tasks from nodes before terminating the Amazon EC2 instances, regardless of the instance-hour boundary. With either behavior, Amazon EMR removes the least active nodes first and blocks instance termination if it could lead to HDFS corruption. `TERMINATE_AT_TASK_COMPLETION` is available only in Amazon EMR releases 4.1.0 and later, and is the default for versions of Amazon EMR earlier than 5.1.0.

- `securityConfiguration`: string — The name of the security configuration applied to the cluster.

- `serviceRole`: string (required) — The IAM role that Amazon EMR assumes in order to access AWS resources on your behalf.

- `stepConcurrencyLevel`: number — Specifies the number of steps that can be executed concurrently.

  The default value is `1` . The maximum value is `256` .

- `steps`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.StepConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.StepConfigProperty.html)[] — A list of steps to run.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — A list of tags associated with a cluster.

- `visibleToAllUsers`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Indicates whether the cluster is visible to all IAM users of the AWS account associated with the cluster.

  If this value is set to `true` , all IAM users of that AWS account can view and manage the cluster if they have the proper policy permissions set. If this value is `false` , only the IAM user that created the cluster can view and manage it. This value can be changed using the SetVisibleToAllUsers action.

  > When you create clusters directly through the EMR console or API, this value is set to `true` by default. However, for `AWS::EMR::Cluster` resources in CloudFormation, the default is `false` .

## Properties

- `additionalInfo`: any — A JSON string for selecting additional features.

- `applications`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.ApplicationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.ApplicationProperty.html)[] — The applications to install on this cluster, for example, Spark, Flink, Oozie, Zeppelin, and so on.

- `attrId`: string — The unique identifier for the cluster.

- `attrMasterPublicDns`: string — The public DNS name of the master node (instance), such as `ec2-12-123-123-123.us-west-2.compute.amazonaws.com` .

- `autoScalingRole`: string — An IAM role for automatic scaling policies.

- `autoTerminationPolicy`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.AutoTerminationPolicyProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.AutoTerminationPolicyProperty.html) — An auto-termination policy for an Amazon EMR cluster.

- `bootstrapActions`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.BootstrapActionConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.BootstrapActionConfigProperty.html)[] — A list of bootstrap actions to run before Hadoop starts on the cluster nodes.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `clusterRef`: [ClusterReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_emr.ClusterReference.html) — A reference to a Cluster resource.

- `configurations`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.ConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.ConfigurationProperty.html)[] — Applies only to Amazon EMR releases 4.x and later. The list of configurations that are supplied to the Amazon EMR cluster.

- `creationStack`: string[]

- `customAmiId`: string — Available only in Amazon EMR releases 5.7.0 and later. The ID of a custom Amazon EBS-backed Linux AMI if the cluster uses a custom AMI.

- `ebsRootVolumeIops`: number — The IOPS, of the Amazon EBS root device volume of the Linux AMI that is used for each Amazon EC2 instance.

- `ebsRootVolumeSize`: number — The size, in GiB, of the Amazon EBS root device volume of the Linux AMI that is used for each Amazon EC2 instance.

- `ebsRootVolumeThroughput`: number — The throughput, in MiB/s, of the Amazon EBS root device volume of the Linux AMI that is used for each Amazon EC2 instance.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `instances`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.JobFlowInstancesConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.JobFlowInstancesConfigProperty.html) — A specification of the number and type of Amazon EC2 instances.

- `jobFlowRole`: string — Also called instance profile and Amazon EC2 role.

- `kerberosAttributes`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.KerberosAttributesProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.KerberosAttributesProperty.html) — Attributes for Kerberos configuration when Kerberos authentication is enabled using a security configuration.

- `logEncryptionKmsKeyId`: string — The AWS KMS key used for encrypting log files.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `logUri`: string — The path to the Amazon S3 location where logs for this cluster are stored.

- `managedScalingPolicy`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.ManagedScalingPolicyProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.ManagedScalingPolicyProperty.html) — Creates or updates a managed scaling policy for an Amazon EMR cluster.

- `name`: string — The name of the cluster.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `osReleaseLabel`: string — The Amazon Linux release specified in a cluster launch RunJobFlow request.

- `placementGroupConfigs`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.PlacementGroupConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.PlacementGroupConfigProperty.html)[]

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `releaseLabel`: string — The Amazon EMR release label, which determines the version of open-source application packages installed on the cluster.

- `scaleDownBehavior`: string — The way that individual Amazon EC2 instances terminate when an automatic scale-in activity occurs or an instance group is resized.

- `securityConfiguration`: string — The name of the security configuration applied to the cluster.

- `serviceRole`: string — The IAM role that Amazon EMR assumes in order to access AWS resources on your behalf.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `stepConcurrencyLevel`: number — Specifies the number of steps that can be executed concurrently.

- `steps`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCluster.StepConfigProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_emr.CfnCluster.StepConfigProperty.html)[] — A list of steps to run.

- `tags`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `tagsRaw`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — A list of tags associated with a cluster.

- `visibleToAllUsers`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Indicates whether the cluster is visible to all IAM users of the AWS account associated with the cluster.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForCluster(resource: IClusterRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `fromClusterId(scope: Construct, id: string, clusterId: string): IClusterRef` (static) — Creates a new IClusterRef from a clusterId.

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnCluster(x: any): boolean` (static) — Checks whether the given object is a CfnCluster.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
